; bouncing ball demo

(define root (new-SoSeparator))
; always ref the root
(-> root 'ref)
(define viewer (examiner root))
(-> viewer 'setViewing 0)

(load "game.scm")

(define *playfield-box* (new-SbBox3f -1 -1 -1 1 1 1))
(define *playfield-faces* (make-vector 6 -1))

(define (new-Ball root pos color)
  (define ball-root (new-SoSeparator))
  (-> ball-root 'ref)
  (define ball (new-SoSphere))
  (-> (-> ball 'radius) 'setValue 0.1)
  (define cone (new-SoCone))
  (-> (-> cone 'bottomRadius) 'setValue 0.1)
  (-> (-> cone 'height) 'setValue 0.2)
  (addChildren ball-root color ball)

  (define actor (new-Actor root ball-root pos))
  (send actor 'addTag 'ball)

  (send actor 'addCollisionHandler viewer '(ball)
	(lambda (self other) (elastic-collision self other)))
  (send actor 'addBoundsCheck *playfield-box* *playfield-faces*)
  
  actor)

(for-each
 (lambda (color)
   (define ball (new-Ball root 
			  (vector (random-float) (random-float) 0) 
			  color))
   (send ball 'setVelocity (vector (* 1.5 (random-float)) 
				   (* 1.5 (random-float)) 
				   0))
   )
 (list yellow white cyan purple))
