; VelocityEngine demo

(define root (new-SoSeparator))
; always ref the root
(-> root 'ref)
(define viewer (examiner root))
(-> viewer 'setViewing 0)

(load "game.scm")

(define (switch-ball root pos color)
  (define ball-root (new-SoSeparator))
  (-> ball-root 'ref)
  (define ball (new-SoSphere))
  (-> (-> ball 'radius) 'setValue 0.1)
  (define cone (new-SoCone))
  (-> (-> cone 'bottomRadius) 'setValue 0.1)
  (-> (-> cone 'height) 'setValue 0.2)
  (addChildren ball-root color ball)

  (define actor (new-Actor root ball-root pos))

  (define alarm-cb
    (let ((old ball)
	  (new cone)
	  (temp #f)
	  (time (new-SbTime 1.0)))
      (lambda (user-data dummy)
	(-> old 'ref)
	(-> ball-root 'replaceChild old new)
	(set! temp old)
	(set! old new)
	(set! new temp)
	(-> alarm 'setTimeFromNow time)
	(-> alarm 'schedule)
	)))
  (define alarm (sensor new-SoAlarmSensor alarm-cb))
  (alarm-cb #f alarm)

  actor)

(define ball (switch-ball root #(0 0 0) blue))
  
(keyboard-handler root
 (lambda (event)
   (cond (*keyboard-active*
	  (if (= 1 (SO_KEY_PRESS_EVENT event LEFT_ARROW))
	      (send ball 'setVelocity #(-1 0 0)))
	  (if (= 1 (SO_KEY_PRESS_EVENT event RIGHT_ARROW))
	      (send ball 'setVelocity #(1 0 0)))
	  (if (= 1 (SO_KEY_PRESS_EVENT event DOWN_ARROW))
	      (send ball 'setVelocity #(0 -1 0)))
	  (if (= 1 (SO_KEY_PRESS_EVENT event UP_ARROW))
	      (send ball 'setVelocity #(0 1 0)))
	  ))
   ))
