(define (vector-dot v1 v2)
  (do ((sum 0 (+ sum (* (vector-ref v1 i) (vector-ref v2 i))))
       (i 0 (+ i 1)))
      ((= i (vector-length v1)) sum)))

(define (vector-scale k v)
  (do ((i 0 (+ i 1)))
      ((= i (vector-length v)) v)
    (vector-set! v i (* k (vector-ref v i)))))

(define (vector-add v1 v2)
  (do ((i 0 (+ i 1)))
      ((= i (vector-length v1)) v1)
    (vector-set! v1 i (+ (vector-ref v1 i) (vector-ref v2 i)))))

(define (vector-normalize v)
  (vector-scale (/ 1 (sqrt (vector-dot v v))) v))

(define (rebase-vector axis1 axis2 v)
  (vector (vector-dot axis1 v)
	  (vector-dot axis2 v)))

